import mapboxgl from 'mapbox-gl'
import 'mapbox-gl/dist/mapbox-gl.css'



export default {
    name: 'Style',
    components: {},
    data() {
        return {
        }
    },
    computed: {},
    watch: {

    },
    mounted() {
        this.map = this.initMap('map')
        this.map.on('load', () => {
            this.map.addSource('dx-tile-source', {
                "type": "raster",
                'tiles': [
                    'http://t0.tianditu.com/DataServer?T=ter_w&X={x}&Y={y}&L={z}&tk=b055e3a80de633c788f673dfcb164aa4'
                ],
                'tileSize': 256
            })
            this.map.addSource('label-tile-source', {
                "type": "raster",
                'tiles': [
                    'http://t0.tianditu.com/DataServer?T=cva_w&X={x}&Y={y}&L={z}&tk=b055e3a80de633c788f673dfcb164aa4'
                ],
                'tileSize': 256
            })
            this.map.addLayer({
                "id": 'dx-tile-layer',
                "type": "raster",
                "source": "dx-tile-source",
                "minzoom": 0,
                "maxzoom": 18,
                "layout": {}
            })
            this.map.addLayer({
                "id": "label-tile-layer",
                "type": "raster",
                "source": "label-tile-source",
                "minzoom": 0,
                "maxzoom": 18,
                "layout": {},
                "paint": {
                    'raster-fade-duration': 0
                }
            })
        })
    },
    methods: {



        initMap(id) {
            mapboxgl.accessToken = 'pk.eyJ1IjoiYmVpeWFuIiwiYSI6ImNqNjV2cXpybjI1c2wzM3A4d3RqYmw5NHkifQ.NvGAphptR7LDZZVYC--tWg'
            const map = new mapboxgl.Map({
                container: id, // container ID
                style: 'mapbox://styles/mapbox/streets-v11', // style URL
                center: [108.60855921468936, 31.360845525231824], // starting position [lng, lat]  // 10.78/39.9195/116.3727
                zoom: 2.654848503234103, // 10.78 starting zoom
                hash: false,
                attributionControl: false,
                customAttribution: 'my',
                logoPosition: 'top-left',
            })

            map.addControl(new mapboxgl.NavigationControl())
            map.addControl(new mapboxgl.GeolocateControl({
                positionOptions: {
                    enableHighAccuracy: true
                },
                trackUserLocation: true
            }))
            const scale = new mapboxgl.ScaleControl({
                maxWidth: 80,
                unit: 'imperial'
            })
            map.addControl(scale)
            scale.setUnit('metric')
            map.addControl(new mapboxgl.FullscreenControl())


            // The `click` event is an example of a `MapMouseEvent`.
            // Set up an event listener on the map.
            map.on('click', (e) => {
                // The event object (e) contains information like the
                // coordinates of the point on the map that was clicked.
                console.log('A click event has occurred at ' + e.lngLat)
                console.log('curr zoom:', map.getZoom())
                console.log('curr center:', map.getCenter().toString())
            })
            return map
        }
    }


}